commit 731f4bf14fc89a595abb780a969d03e82b807763
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Fri Feb 4 00:21:11 2022

    i386: Do not use %ecx DRAP for functions that use __builtin_eh_return [PR104362]
    
    %ecx can't be used for both DRAP register and eh_return.  Adjust find_drap_reg
    to choose %edi for functions that uses __builtin_eh_return to avoid the assert
    in ix86_expand_epilogue that enforces this rule.
    
    2022-02-03  Uroš Bizjak  <ubizjak@gmail.com>
    
    gcc/ChangeLog:
    
            PR target/104362
            * config/i386/i386.c (find_drap_reg): For 32bit targets
            return DI_REG if function uses __builtin_eh_return.
    
    gcc/testsuite/ChangeLog:
    
            PR target/104362
            * gcc.target/i386/pr104362.c: New test.

diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index 8e8c8beb366..bf471735d58 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -7219,7 +7219,8 @@ find_drap_reg (void)
 	 register in such case.  */
       if (DECL_STATIC_CHAIN (decl)
 	  || cfun->machine->no_caller_saved_registers
-	  || crtl->tail_call_emit)
+	  || crtl->tail_call_emit
+	  || crtl->calls_eh_return)
 	return DI_REG;
 
       /* Reuse static chain register if it isn't used for parameter
diff --git a/gcc/testsuite/gcc.target/i386/pr104362.c b/gcc/testsuite/gcc.target/i386/pr104362.c
new file mode 100644
index 00000000000..5e5422e2679
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr104362.c
@@ -0,0 +1,24 @@
+/* PR target/104362 */
+/* { dg-do compile } */
+/* { dg-options "-mavx512f" } */
+
+struct _Unwind_Context
+{
+  void *ra;
+  char array[48];
+};
+
+extern long uw_install_context_1 (struct _Unwind_Context *);
+
+void
+_Unwind_RaiseException (void)
+{
+  struct _Unwind_Context this_context, cur_context;
+  __builtin_memset(&this_context, 55, sizeof(this_context));
+  long offset = uw_install_context_1 (&this_context);
+  __builtin_memcpy (&this_context, &cur_context,
+                    sizeof (struct _Unwind_Context));
+  void *handler = __builtin_frob_return_addr ((&cur_context)->ra);
+  uw_install_context_1 (&cur_context);
+  __builtin_eh_return (offset, handler);
+}

